#include <aterm2.h>
#include "options.h"

int parse();
char file_name[256];
extern ATerm parse_tree;
extern FILE *yyin;
extern int yylineno;
extern ATerm yylval;

extern int yydebug;

FILE *outfile;

ATerm parse_file(char *name)
{
  ATermList decls;
  int res;

  if(name == NULL) {
    yyin = stdin;
    fprintf(stderr, "parsing stdin ...");
  } else {
    yyin = fopen(name, "r");
    yylineno = 0;
    if(!yyin) {
      fprintf(stderr, "no such file: %s\n", name);
      exit(1);
    }
    if(!silent)
      fprintf(stderr, "parsing %s ...", file_name);
  }
  if((res = parse()) == 0) {
    if(!silent)
      ATfprintf(stderr, " succeeded\n", parse_tree);
    return parse_tree;
  } else {
    ATfprintf(stderr, " parsing %s failed\n\n", name);
    exit(1);
  }
}

int main(int argc, char *argv[])
{
  ATerm tree;

  ATinit(argc, argv, &tree);
  ATprotect(&parse_tree);

  process_options(argc, argv);

  yydebug = 0;
  tree = parse_file(input_file);
  /* Open output file */
  if (output_file == NULL)
    outfile = stdout;
  else
    outfile = fopen(output_file, "w");
  if(binary_output)
    ATwriteToBinaryFile(tree, outfile);
  else
    ATwriteToTextFile(tree, outfile);
  exit(0);
}
